/* =================================================================
 *
 * Copyright (C) 1989, 1990, 1993 Linas Vepstas
 *
 *                   All Rights Reserved
 *
 * Permission to use, copy, and modify this software and its 
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies 
 * and that both the copyright notice and this permission notice 
 * appear in supporting documentation.
 *
 * Permission to redistribute this software and its documentation
 * is hereby granted, provided that such redistribution is not 
 * performed for monetary profit or gain.
 *
 * Redistribution for profit without express written consent is
 * prohibited.  Contact the author if you wish to use this software 
 * and/or its documentation in a commercial product.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY OF ANY KIND.  
 * THE AUTHOR DISCLAIMS ALL EXPRESS AND IMPLIED WARRANTIES, INCLUDING 
 * BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND 
 * FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * IN NO EVENT SHALL THE AUTHOR BE HELD LIABLE FOR ANY SPECIAL, DIRECT, 
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING 
 * IN LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION 
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Bug reports or fixes may be sent to the author, who may or may not 
 * act upon them as he desires.
 * 
 * The author's last known address is:
 * 
 *                       Linas Vepstas
 *                     1518 Enfield Road
 *                  Austin, Texas 78703-3424
 *                      1-(512)-499-8246
 *                    linas@austin.ibm.com
 *
 * =================================================================
 */
/*
 *	This include file has definitions used by the U-May library routines
 *	and the maydaemon. The application programmer does not need this
 *	information.
 */

#include "sysdep.h"
#include <stdio.h>
#include <values.h>

#ifdef IBM_AIXv221
#include <sys/select.h> /* required for select call */
#else
#define  NFDS(X) ((X) & 0x0000FFFF)
#endif

#ifdef SYS_V_INCLUDES
#include <sys/time.h>	/* required for select call */
#endif

#ifdef NO_VOID_PTR
#define Void	char 	/* if it don't understand pointer to type void */
#else
#define Void	void
#endif

/*
 * Structures used internally be maydaemon
 */

struct general_msg_hdr {
	struct mayProcId sproc; /* sender's proc id */
	long 	msgtype;
	short 	subtype;
	long 	msglen;   /* length of message including this header */
        long	queue_len;	/* senders queue length */
	};

struct create_msg {	/* used by maycreate */
        struct	mayProcId sproc; /* senders (parent's UDP) proc id */
	char 	prog_name [255];  /* file path of program to be execd */
	};

struct create_reply {	/* remote daemon's reply to maycreate */
	struct mayProcId	sproc;  /* sender's proc id */
	long 			errortype;
	char			err_msg [80];
	};

/*
 * Internal message types
 */

#define DAEMONLIST	1
#define CHILDLIST	2

#define DAEMONMSG	0
/* #define CREATE_REQUEST	1   /* obsolete */
#define CREATE_REPLY	2
#define ADDRMSG		3
#define PARENTADDR	4


/* moved to may.h  #define MAYTIMEDOUT	5   /* used by mayReceive */

struct may_msg_list {
	struct may_msg_list *next;
	Void *msg;
	};

/* 
 * the following are anchor points for global data areas 
 */

extern struct mayProcId *may_hosts;	/* linked list of all known daemons */
extern struct mayProcId *open_socks;	/* linked list of all open socks */
extern struct mayProcId *The_udp_sock;	/* pointer into open_socks list */
extern int may_internal_flag;

/* the number of messages queued up, waiting to be read */
extern long may_msg_list_length;

/* pointer to list of cached messages */
extern struct may_msg_list *may_msg_head_ptr;


/* 
 * Usefule macors
 */

#define SIZEOSOX   sizeof (struct sockaddr_in)
#define SIZEOPRO   sizeof (struct mayProcId)

/* used to change mode for internal processing */
#define MAY_INTERNAL_FLAG	456

#ifdef DEBUG
#define Tpr(x) printf x ;
#else
#define Tpr(x)
#endif


extern void mayBreakOutMsg();
extern void mayDumpId();
extern void mayExec();
extern void mayGetId();
extern struct mayProcId *mayGetHosts();

/* =========================== END OF FILE =================== */
