/*
 * edit this file to attain portability
 */

#ifndef __MAY_SYSDEP_H__
#define __MAY_SYSDEP_H__
/* ================================================================ */

/* if you run the IBM AIX version 3.1.5 operating system, uncomment this line */
/* #define IBM_AIXv315 */

/* if you run the IBM AIX version 2.2.1 operating system, uncomment this line */
/* #define IBM_AIXv221 */

/* if you run on a Silicon Graphics Personal Iris, uncomment this line */
/* #define SGI_IRIXv31 */

/* if you run on a Silicon Graphics Iris Indigo, uncomment this line */
/* #define SGI_IRIXv40 */

/* if you run on an HP 9000/710, with HP/UX version 8.07, uncomment this line */
/* #define HP_UXv807 */

/* ================================================================ */
/* Do Not read past here if you found your OS above */

/* if your sockets are found in /usr/include/bsd, uncomment this line */
/* #define BSD_FILESYS */


/* if you run a AT&T System V like Unix, uncomment this line */
/* #define SYS_V_INCLUDES */

/* If your compiler doesn't understand pointers to type void,
 * uncomment this line */
/* #define NO_VOID_PTR */

/* If you have an ANSI-C compliant compiler, uncomment this line */
/* #define ANSI_C */

/* This should handle most ansi c systems if stdc is defined correctly */
#ifdef __STDC__
#define ANSI_C
#endif

/* ================================================================ */
/* Auto setup -- Do Not read past here */
/* --------------------------------*/
#ifdef IBM_AIXv315
#define ANSI_C
#define SYS_V_INCLUDES
#endif
/* --------------------------------*/
#ifdef IBM_AIXv221
#define NO_VOID_PTR

#ifndef _C_func
#define _C_func
#endif

/* #define	SIG_ERR	BADSIG    -- you would think, but NOooo */
#define	SIG_ERR	(-1)
#define EXIT_SUCESS  (0)
#define EXIT_FAILURE (1)
#endif
/* --------------------------------*/
#ifdef SGI_IRIXv31
#define SYS_V_INCLUDES
#define BSD_FILESYS
#define NO_VOID_PTR

#ifndef TRUE
#define TRUE (1)
#endif

#ifndef FALSE
#define FALSE (0)
#endif

#endif
/* --------------------------------*/
#ifdef SGI_IRIXv40
#define ANSI_C
#define SYS_V_INCLUDES

#ifndef TRUE
#define TRUE (1)
#endif

#ifndef FALSE
#define FALSE (0)
#endif

#endif
/* --------------------------------*/
#ifdef HP_UXv807
#define SYS_V_INCLUDES

#ifndef TRUE
#define TRUE (1)
#endif

#ifndef FALSE
#define FALSE (0)
#endif

#include <stdlib.h>

#endif

/* ================================================================ */
/* Auto setup -- Do Not read past here */

#ifdef BSD_FILESYS
#include <bsd/sys/types.h>
#include <bsd/sys/socket.h>
#include <bsd/netinet/in.h>
#include <bsd/netdb.h>
#else
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#endif

#ifdef NO_VOID_PTR
#define Void	char 	/* if it don't understand pointer to type void */
#else
#define Void	void
#endif

#ifdef ANSI_C
#include <stdlib.h>
#endif

#include <stdio.h>

#endif /*  __MAY_SYSDEP_H__  */

/* ====================== END OF FILE ==================== */
